//----------------------------------------------------------------
// Top level DUT
//----------------------------------------------------------------
module dut (
            ref_clk_in,
            reset,
            clock_en_in,
            start_in,
            stop_in,
            pass_out,
            fail_out,
            debug_out
           );

input           ref_clk_in;
input           reset;
input           clock_en_in;
input           start_in;
input           stop_in;

output          pass_out;
output          fail_out;
output          debug_out;

   parameter WIDTH=65;
   wire [WIDTH-1:0] data_out;
   wire 	mmcm_out_clk;
   
   
   top_s3e_vs_c2 top (
		      .CLK0        (mmcm_out_clk),
		      .RST         (~reset),
		      .CE          (start_in&(!stop_in)),
		      .CLK_CNT     (fail_out),
		      .DATA_OUTS   (data_out)
		      );

   assign pass_out = ^data_out;

BUFGCE BUFGCE (
               .O ( mmcm_out_clk ), 
               .CE (clock_en_in),
               .I  (ref_clk_in) );
 
endmodule // dut
//<copyright-disclaimer-start>
//  **************************************************************************************************************
//  * © 2025 Advanced Micro Devices, Inc. All rights reserved.                                                   *
//  * DISCLAIMER                                                                                                 *
//  * The information contained herein is for informational purposes only, and is subject to change              *
//  * without notice. While every precaution has been taken in the preparation of this document, it              *
//  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
//  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
//  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
//  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
//  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
//  * hardware, software or other products described herein.  No license, including implied or                   *
//  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
//  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
//  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
//  *                                                                                                            *
//  **************************************************************************************************************
//<copyright-disclaimer-end>