
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity output_transformation is
    Port ( clk : in std_logic;
	        x1,x2,x3,x4,x5,x6,x7,x8 : in std_logic_vector(7 downto 0);
           k1,k2,k3,k4,k5,k6,k7,k8 : in std_logic_vector(7 downto 0);
           y1,y2,y3,y4,y5,y6,y7,y8 : out std_logic_vector(7 downto 0)
			  );
end output_transformation;

architecture behavioral of output_transformation is

begin

process(clk)
begin
if (clk'event and clk='1') then
  y1 <= x1 xor k1; y2 <= x2 + k2; y3 <= x3 + k3; y4 <= x4 xor k4;
  y5 <= x5 xor k5; y6 <= x6 + k6; y7 <= x7 + k7; y8 <= x8 xor k8;
end if;
end process;

end behavioral;
--<copyright-disclaimer-start>
--  **************************************************************************************************************
--  * © 2025 Advanced Micro Devices, Inc. All rights reserved.                                                   *
--  * DISCLAIMER                                                                                                 *
--  * The information contained herein is for informational purposes only, and is subject to change              *
--  * without notice. While every precaution has been taken in the preparation of this document, it              *
--  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
--  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
--  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
--  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
--  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
--  * hardware, software or other products described herein.  No license, including implied or                   *
--  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
--  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
--  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
--  *                                                                                                            *
--  **************************************************************************************************************
--<copyright-disclaimer-end>