// Copyright 1986-2022 Xilinx, Inc. All Rights Reserved.
// Copyright 2022-2024 Advanced Micro Devices, Inc. All Rights Reserved.
// -------------------------------------------------------------------------------

`timescale 1 ps / 1 ps

(* BLOCK_STUB = "true" *)
module system_bd (
  pl0_ref_clk_0,
  pl0_resetn_0,
  ddr4_dimm1_dq,
  ddr4_dimm1_dqs_t,
  ddr4_dimm1_dqs_c,
  ddr4_dimm1_adr,
  ddr4_dimm1_ba,
  ddr4_dimm1_bg,
  ddr4_dimm1_act_n,
  ddr4_dimm1_reset_n,
  ddr4_dimm1_ck_t,
  ddr4_dimm1_ck_c,
  ddr4_dimm1_cke,
  ddr4_dimm1_cs_n,
  ddr4_dimm1_dm_n,
  ddr4_dimm1_odt,
  ddr4_dimm1_sma_clk_clk_p,
  ddr4_dimm1_sma_clk_clk_n
);

  (* X_INTERFACE_INFO = "xilinx.com:signal:clock:1.0 CLK.PL0_REF_CLK_0 CLK" *)
  (* X_INTERFACE_MODE = "master CLK.PL0_REF_CLK_0" *)
  (* X_INTERFACE_PARAMETER = "XIL_INTERFACENAME CLK.PL0_REF_CLK_0, FREQ_HZ 99999908, FREQ_TOLERANCE_HZ 0, PHASE 0.0, CLK_DOMAIN bd_314d_pspmc_0_0_pl0_ref_clk, INSERT_VIP 0" *)
  output pl0_ref_clk_0;
  (* X_INTERFACE_INFO = "xilinx.com:signal:reset:1.0 RST.PL0_RESETN_0 RST" *)
  (* X_INTERFACE_MODE = "master RST.PL0_RESETN_0" *)
  (* X_INTERFACE_PARAMETER = "XIL_INTERFACENAME RST.PL0_RESETN_0, POLARITY ACTIVE_LOW, INSERT_VIP 0" *)
  output [0:0]pl0_resetn_0;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 DQ" *)
  (* X_INTERFACE_MODE = "master ddr4_dimm1" *)
  (* X_INTERFACE_PARAMETER = "XIL_INTERFACENAME ddr4_dimm1, CAN_DEBUG false, TIMEPERIOD_PS 1250, MEMORY_TYPE COMPONENTS, DATA_WIDTH 8, CS_ENABLED true, DATA_MASK_ENABLED true, SLOT Single, MEM_ADDR_MAP ROW_COLUMN_BANK, BURST_LENGTH 8, AXI_ARBITRATION_SCHEME TDM, CAS_LATENCY 11, CAS_WRITE_LATENCY 11" *)
  inout [63:0]ddr4_dimm1_dq;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 DQS_T" *)
  inout [7:0]ddr4_dimm1_dqs_t;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 DQS_C" *)
  inout [7:0]ddr4_dimm1_dqs_c;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 ADR" *)
  output [16:0]ddr4_dimm1_adr;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 BA" *)
  output [1:0]ddr4_dimm1_ba;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 BG" *)
  output [1:0]ddr4_dimm1_bg;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 ACT_N" *)
  output ddr4_dimm1_act_n;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 RESET_N" *)
  output ddr4_dimm1_reset_n;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 CK_T" *)
  output ddr4_dimm1_ck_t;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 CK_C" *)
  output ddr4_dimm1_ck_c;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 CKE" *)
  output ddr4_dimm1_cke;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 CS_N" *)
  output ddr4_dimm1_cs_n;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 DM_N" *)
  inout [7:0]ddr4_dimm1_dm_n;
  (* X_INTERFACE_INFO = "xilinx.com:interface:ddr4:1.0 ddr4_dimm1 ODT" *)
  output ddr4_dimm1_odt;
  (* X_INTERFACE_INFO = "xilinx.com:interface:diff_clock:1.0 ddr4_dimm1_sma_clk CLK_P" *)
  (* X_INTERFACE_MODE = "slave ddr4_dimm1_sma_clk" *)
  (* X_INTERFACE_PARAMETER = "XIL_INTERFACENAME ddr4_dimm1_sma_clk, CAN_DEBUG false, FREQ_HZ 200000000" *)
  input ddr4_dimm1_sma_clk_clk_p;
  (* X_INTERFACE_INFO = "xilinx.com:interface:diff_clock:1.0 ddr4_dimm1_sma_clk CLK_N" *)
  input ddr4_dimm1_sma_clk_clk_n;

  // stub module has no contents

endmodule
