// (c) Copyright 1986-2022 Xilinx, Inc. All Rights Reserved.
// (c) Copyright 2022-2024 Advanced Micro Devices, Inc. All rights reserved.
// 
// This file contains confidential and proprietary information
// of AMD and is protected under U.S. and international copyright
// and other intellectual property laws.
// 
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// AMD, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND AMD HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) AMD shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or AMD had been advised of the
// possibility of the same.
// 
// CRITICAL APPLICATIONS
// AMD products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of AMD products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
// 
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES.
// 
// DO NOT MODIFY THIS FILE.

// IP VLNV: xilinx.com:ip:perf_axi_tg:1.0
// IP Revision: 15

// The following must be inserted into your Verilog file for this
// core to be instantiated. Change the instance name and port connections
// (in parentheses) to your own signal names.

//----------- Begin Cut here for INSTANTIATION Template ---// INST_TAG
perf_axi_tg_pl_to_pl your_instance_name (
  .clk(clk),                    // input wire clk
  .tg_rst_n(tg_rst_n),          // input wire tg_rst_n
  .axi_awid(axi_awid),          // output wire [1 : 0] axi_awid
  .axi_awaddr(axi_awaddr),      // output wire [47 : 0] axi_awaddr
  .axi_awlen(axi_awlen),        // output wire [7 : 0] axi_awlen
  .axi_awsize(axi_awsize),      // output wire [2 : 0] axi_awsize
  .axi_awburst(axi_awburst),    // output wire [1 : 0] axi_awburst
  .axi_awlock(axi_awlock),      // output wire [0 : 0] axi_awlock
  .axi_awcache(axi_awcache),    // output wire [3 : 0] axi_awcache
  .axi_awprot(axi_awprot),      // output wire [2 : 0] axi_awprot
  .axi_awregion(axi_awregion),  // output wire [3 : 0] axi_awregion
  .axi_awqos(axi_awqos),        // output wire [3 : 0] axi_awqos
  .axi_awuser(axi_awuser),      // output wire [15 : 0] axi_awuser
  .axi_awvalid(axi_awvalid),    // output wire axi_awvalid
  .axi_awready(axi_awready),    // input wire axi_awready
  .axi_wdata(axi_wdata),        // output wire [511 : 0] axi_wdata
  .axi_wstrb(axi_wstrb),        // output wire [63 : 0] axi_wstrb
  .axi_wlast(axi_wlast),        // output wire axi_wlast
  .axi_wuser(axi_wuser),        // output wire [15 : 0] axi_wuser
  .axi_wvalid(axi_wvalid),      // output wire axi_wvalid
  .axi_wready(axi_wready),      // input wire axi_wready
  .axi_bid(axi_bid),            // input wire [1 : 0] axi_bid
  .axi_bresp(axi_bresp),        // input wire [1 : 0] axi_bresp
  .axi_buser(axi_buser),        // input wire [15 : 0] axi_buser
  .axi_bvalid(axi_bvalid),      // input wire axi_bvalid
  .axi_bready(axi_bready),      // output wire axi_bready
  .axi_arid(axi_arid),          // output wire [1 : 0] axi_arid
  .axi_araddr(axi_araddr),      // output wire [47 : 0] axi_araddr
  .axi_arlen(axi_arlen),        // output wire [7 : 0] axi_arlen
  .axi_arsize(axi_arsize),      // output wire [2 : 0] axi_arsize
  .axi_arburst(axi_arburst),    // output wire [1 : 0] axi_arburst
  .axi_arlock(axi_arlock),      // output wire [0 : 0] axi_arlock
  .axi_arcache(axi_arcache),    // output wire [3 : 0] axi_arcache
  .axi_arprot(axi_arprot),      // output wire [2 : 0] axi_arprot
  .axi_arregion(axi_arregion),  // output wire [3 : 0] axi_arregion
  .axi_arqos(axi_arqos),        // output wire [3 : 0] axi_arqos
  .axi_aruser(axi_aruser),      // output wire [15 : 0] axi_aruser
  .axi_arvalid(axi_arvalid),    // output wire axi_arvalid
  .axi_arready(axi_arready),    // input wire axi_arready
  .axi_rid(axi_rid),            // input wire [1 : 0] axi_rid
  .axi_rdata(axi_rdata),        // input wire [511 : 0] axi_rdata
  .axi_rresp(axi_rresp),        // input wire [1 : 0] axi_rresp
  .axi_rlast(axi_rlast),        // input wire axi_rlast
  .axi_ruser(axi_ruser),        // input wire [15 : 0] axi_ruser
  .axi_rvalid(axi_rvalid),      // input wire axi_rvalid
  .axi_rready(axi_rready),      // output wire axi_rready
  .axi_tg_start(axi_tg_start),  // input wire axi_tg_start
  .axi_tg_done(axi_tg_done),    // output wire axi_tg_done
  .axi_tg_error(axi_tg_error)  // output wire axi_tg_error
);
// INST_TAG_END ------ End INSTANTIATION Template ---------

// You must compile the wrapper file perf_axi_tg_pl_to_pl.v when simulating
// the core, perf_axi_tg_pl_to_pl. When compiling the wrapper file, be sure to
// reference the Verilog simulation library.

