-- (c) Copyright 1986-2022 Xilinx, Inc. All Rights Reserved.
-- (c) Copyright 2022-2024 Advanced Micro Devices, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of AMD and is protected under U.S. and international copyright
-- and other intellectual property laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- AMD, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND AMD HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) AMD shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or AMD had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- AMD products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of AMD products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES.
-- 
-- DO NOT MODIFY THIS FILE.
-- IP VLNV: xilinx.com:ip:perf_axi_tg:1.0
-- IP Revision: 15

-- The following code must appear in the VHDL architecture header.

------------- Begin Cut here for COMPONENT Declaration ------ COMP_TAG
COMPONENT perf_axi_tg_pl_to_ps
  PORT (
    clk : IN STD_LOGIC;
    tg_rst_n : IN STD_LOGIC;
    axi_awid : OUT STD_LOGIC_VECTOR(1 DOWNTO 0);
    axi_awaddr : OUT STD_LOGIC_VECTOR(47 DOWNTO 0);
    axi_awlen : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
    axi_awsize : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
    axi_awburst : OUT STD_LOGIC_VECTOR(1 DOWNTO 0);
    axi_awlock : OUT STD_LOGIC_VECTOR(0 DOWNTO 0);
    axi_awcache : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    axi_awprot : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
    axi_awregion : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    axi_awqos : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    axi_awuser : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
    axi_awvalid : OUT STD_LOGIC;
    axi_awready : IN STD_LOGIC;
    axi_wdata : OUT STD_LOGIC_VECTOR(127 DOWNTO 0);
    axi_wstrb : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
    axi_wlast : OUT STD_LOGIC;
    axi_wuser : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
    axi_wvalid : OUT STD_LOGIC;
    axi_wready : IN STD_LOGIC;
    axi_bid : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
    axi_bresp : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
    axi_buser : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
    axi_bvalid : IN STD_LOGIC;
    axi_bready : OUT STD_LOGIC;
    axi_arid : OUT STD_LOGIC_VECTOR(1 DOWNTO 0);
    axi_araddr : OUT STD_LOGIC_VECTOR(47 DOWNTO 0);
    axi_arlen : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
    axi_arsize : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
    axi_arburst : OUT STD_LOGIC_VECTOR(1 DOWNTO 0);
    axi_arlock : OUT STD_LOGIC_VECTOR(0 DOWNTO 0);
    axi_arcache : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    axi_arprot : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
    axi_arregion : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    axi_arqos : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    axi_aruser : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
    axi_arvalid : OUT STD_LOGIC;
    axi_arready : IN STD_LOGIC;
    axi_rid : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
    axi_rdata : IN STD_LOGIC_VECTOR(127 DOWNTO 0);
    axi_rresp : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
    axi_rlast : IN STD_LOGIC;
    axi_ruser : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
    axi_rvalid : IN STD_LOGIC;
    axi_rready : OUT STD_LOGIC;
    axi_tg_start : IN STD_LOGIC;
    axi_tg_done : OUT STD_LOGIC;
    axi_tg_error : OUT STD_LOGIC 
  );
END COMPONENT;
-- COMP_TAG_END ------ End COMPONENT Declaration ------------

-- The following code must appear in the VHDL architecture
-- body. Substitute your own instance name and net names.

------------- Begin Cut here for INSTANTIATION Template ----- INST_TAG
your_instance_name : perf_axi_tg_pl_to_ps
  PORT MAP (
    clk => clk,
    tg_rst_n => tg_rst_n,
    axi_awid => axi_awid,
    axi_awaddr => axi_awaddr,
    axi_awlen => axi_awlen,
    axi_awsize => axi_awsize,
    axi_awburst => axi_awburst,
    axi_awlock => axi_awlock,
    axi_awcache => axi_awcache,
    axi_awprot => axi_awprot,
    axi_awregion => axi_awregion,
    axi_awqos => axi_awqos,
    axi_awuser => axi_awuser,
    axi_awvalid => axi_awvalid,
    axi_awready => axi_awready,
    axi_wdata => axi_wdata,
    axi_wstrb => axi_wstrb,
    axi_wlast => axi_wlast,
    axi_wuser => axi_wuser,
    axi_wvalid => axi_wvalid,
    axi_wready => axi_wready,
    axi_bid => axi_bid,
    axi_bresp => axi_bresp,
    axi_buser => axi_buser,
    axi_bvalid => axi_bvalid,
    axi_bready => axi_bready,
    axi_arid => axi_arid,
    axi_araddr => axi_araddr,
    axi_arlen => axi_arlen,
    axi_arsize => axi_arsize,
    axi_arburst => axi_arburst,
    axi_arlock => axi_arlock,
    axi_arcache => axi_arcache,
    axi_arprot => axi_arprot,
    axi_arregion => axi_arregion,
    axi_arqos => axi_arqos,
    axi_aruser => axi_aruser,
    axi_arvalid => axi_arvalid,
    axi_arready => axi_arready,
    axi_rid => axi_rid,
    axi_rdata => axi_rdata,
    axi_rresp => axi_rresp,
    axi_rlast => axi_rlast,
    axi_ruser => axi_ruser,
    axi_rvalid => axi_rvalid,
    axi_rready => axi_rready,
    axi_tg_start => axi_tg_start,
    axi_tg_done => axi_tg_done,
    axi_tg_error => axi_tg_error
  );
-- INST_TAG_END ------ End INSTANTIATION Template ---------

-- You must compile the wrapper file perf_axi_tg_pl_to_ps.vhd when simulating
-- the core, perf_axi_tg_pl_to_ps. When compiling the wrapper file, be sure to
-- reference the VHDL simulation library.



