#Copyright (C) 2025, Advanced Micro Devices, Inc. All rights reserved.
#SPDX-License-Identifier: MIT

set PL_SRC_REPO [lindex $argv 0]
set GEMM_SIZE [lindex $argv 1]
set IP_NAME "gemm_large_ocm"
set project "project_gemm_large_ocm"
create_project $project ./$project -part xcvc1902-vsva2197-2MP-e-S -force

read_vhdl -vhdl2008  ${PL_SRC_REPO}/rtl/BDELAY.vhd       
read_vhdl -vhdl2008  ${PL_SRC_REPO}/rtl/FIXGEMM.vhd          
read_vhdl -vhdl2008  ${PL_SRC_REPO}/rtl/SDELAY.vhd
read_vhdl -vhdl2008  ${PL_SRC_REPO}/rtl/sfixed_pkg.vhd
read_vhdl -vhdl2008  ${PL_SRC_REPO}/rtl/cfixed_pkg.vhd  
read_vhdl -vhdl2008  ${PL_SRC_REPO}/rtl/DSP_GW.vhd              
read_vhdl -vhdl2008  ${PL_SRC_REPO}/rtl/FIXGEMM_WRAPPER.vhd  
add_files -norecurse ${PL_SRC_REPO}/rtl/control_logic.sv        
add_files -norecurse ${PL_SRC_REPO}/rtl/gemm_top.sv          
add_files -norecurse ${PL_SRC_REPO}/rtl/ps_slave.sv  
add_files -norecurse ${PL_SRC_REPO}/rtl/DSP_data_controller.sv  
add_files -norecurse ${PL_SRC_REPO}/rtl/op_uram.sv           
add_files -norecurse ${PL_SRC_REPO}/rtl/row_uram.sv
add_files -norecurse ${PL_SRC_REPO}/rtl/col_uram.sv     
add_files -norecurse ${PL_SRC_REPO}/rtl/gemm_large_ocm.sv    
add_files -norecurse ${PL_SRC_REPO}/rtl/partial_sum_bram.sv  
add_files -norecurse ${PL_SRC_REPO}/rtl/synchronizer.sv


if {$GEMM_SIZE == 32} {
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_00.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_01.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_02.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_03.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_04.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_05.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_06.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_07.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_08.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_09.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_10.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_11.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_12.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_13.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_14.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_15.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_16.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_17.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_18.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_19.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_20.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_21.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_22.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_23.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_24.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_25.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_26.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_27.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_28.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_29.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_30.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_31.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_32.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_33.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_34.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_35.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_36.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_37.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_38.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_39.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_40.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_41.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_42.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_43.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_44.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_45.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_46.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_47.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_48.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_49.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_50.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_51.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_52.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_53.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_54.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_55.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_56.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_57.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_58.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_59.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_60.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_61.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_62.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/row_init_63.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init00.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init01.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init02.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init03.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init04.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init05.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init06.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init07.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init08.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init09.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init10.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init11.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init12.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init13.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init14.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init15.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init16.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init17.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init18.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init19.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init20.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init21.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init22.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init23.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init24.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init25.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init26.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init27.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init28.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init29.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init30.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init31.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init32.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init33.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init34.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init35.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init36.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init37.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init38.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init39.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init40.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init41.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init42.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init43.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init44.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init45.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init46.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init47.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init48.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init49.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init50.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init51.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init52.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init53.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init54.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init55.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init56.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init57.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init58.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init59.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init60.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init61.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init62.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_32x32x32/col_init63.mem
}
if {$GEMM_SIZE == 64} {
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_00.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_01.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_02.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_03.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_04.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_05.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_06.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_07.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_08.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_09.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_10.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_11.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_12.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_13.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_14.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_15.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_16.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_17.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_18.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_19.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_20.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_21.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_22.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_23.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_24.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_25.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_26.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_27.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_28.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_29.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_30.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_31.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_32.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_33.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_34.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_35.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_36.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_37.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_38.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_39.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_40.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_41.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_42.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_43.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_44.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_45.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_46.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_47.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_48.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_49.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_50.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_51.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_52.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_53.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_54.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_55.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_56.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_57.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_58.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_59.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_60.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_61.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_62.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/row_init_63.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init00.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init01.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init02.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init03.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init04.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init05.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init06.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init07.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init08.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init09.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init10.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init11.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init12.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init13.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init14.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init15.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init16.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init17.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init18.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init19.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init20.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init21.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init22.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init23.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init24.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init25.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init26.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init27.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init28.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init29.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init30.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init31.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init32.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init33.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init34.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init35.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init36.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init37.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init38.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init39.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init40.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init41.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init42.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init43.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init44.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init45.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init46.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init47.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init48.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init49.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init50.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init51.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init52.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init53.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init54.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init55.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init56.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init57.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init58.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init59.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init60.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init61.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init62.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_64x64x64/col_init63.mem
}
if {$GEMM_SIZE == 128} {
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_00.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_01.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_02.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_03.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_04.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_05.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_06.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_07.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_08.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_09.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_10.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_11.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_12.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_13.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_14.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_15.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_16.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_17.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_18.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_19.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_20.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_21.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_22.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_23.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_24.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_25.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_26.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_27.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_28.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_29.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_30.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_31.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_32.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_33.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_34.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_35.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_36.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_37.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_38.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_39.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_40.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_41.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_42.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_43.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_44.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_45.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_46.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_47.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_48.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_49.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_50.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_51.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_52.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_53.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_54.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_55.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_56.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_57.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_58.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_59.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_60.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_61.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_62.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/row_init_63.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init00.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init01.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init02.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init03.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init04.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init05.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init06.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init07.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init08.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init09.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init10.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init11.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init12.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init13.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init14.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init15.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init16.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init17.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init18.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init19.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init20.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init21.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init22.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init23.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init24.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init25.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init26.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init27.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init28.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init29.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init30.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init31.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init32.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init33.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init34.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init35.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init36.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init37.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init38.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init39.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init40.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init41.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init42.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init43.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init44.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init45.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init46.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init47.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init48.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init49.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init50.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init51.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init52.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init53.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init54.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init55.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init56.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init57.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init58.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init59.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init60.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init61.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init62.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_128x128x128/col_init63.mem
}
if {$GEMM_SIZE == 256} {
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_00.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_01.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_02.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_03.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_04.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_05.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_06.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_07.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_08.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_09.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_10.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_11.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_12.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_13.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_14.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_15.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_16.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_17.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_18.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_19.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_20.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_21.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_22.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_23.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_24.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_25.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_26.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_27.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_28.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_29.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_30.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_31.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_32.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_33.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_34.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_35.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_36.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_37.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_38.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_39.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_40.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_41.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_42.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_43.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_44.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_45.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_46.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_47.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_48.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_49.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_50.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_51.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_52.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_53.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_54.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_55.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_56.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_57.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_58.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_59.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_60.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_61.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_62.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/row_init_63.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init00.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init01.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init02.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init03.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init04.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init05.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init06.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init07.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init08.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init09.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init10.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init11.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init12.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init13.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init14.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init15.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init16.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init17.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init18.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init19.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init20.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init21.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init22.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init23.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init24.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init25.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init26.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init27.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init28.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init29.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init30.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init31.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init32.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init33.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init34.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init35.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init36.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init37.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init38.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init39.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init40.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init41.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init42.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init43.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init44.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init45.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init46.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init47.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init48.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init49.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init50.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init51.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init52.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init53.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init54.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init55.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init56.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init57.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init58.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init59.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init60.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init61.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init62.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_256x256x256/col_init63.mem
}
if {$GEMM_SIZE == 512} {
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_00.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_01.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_02.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_03.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_04.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_05.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_06.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_07.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_08.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_09.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_10.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_11.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_12.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_13.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_14.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_15.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_16.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_17.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_18.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_19.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_20.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_21.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_22.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_23.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_24.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_25.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_26.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_27.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_28.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_29.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_30.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_31.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_32.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_33.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_34.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_35.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_36.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_37.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_38.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_39.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_40.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_41.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_42.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_43.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_44.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_45.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_46.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_47.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_48.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_49.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_50.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_51.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_52.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_53.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_54.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_55.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_56.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_57.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_58.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_59.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_60.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_61.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_62.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/row_init_63.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init00.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init01.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init02.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init03.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init04.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init05.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init06.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init07.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init08.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init09.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init10.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init11.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init12.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init13.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init14.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init15.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init16.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init17.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init18.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init19.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init20.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init21.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init22.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init23.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init24.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init25.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init26.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init27.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init28.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init29.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init30.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init31.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init32.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init33.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init34.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init35.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init36.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init37.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init38.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init39.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init40.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init41.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init42.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init43.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init44.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init45.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init46.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init47.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init48.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init49.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init50.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init51.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init52.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init53.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init54.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init55.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init56.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init57.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init58.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init59.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init60.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init61.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init62.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_512x512x512/col_init63.mem
}
if {$GEMM_SIZE == 1024} {
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_00.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_01.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_02.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_03.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_04.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_05.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_06.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_07.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_08.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_09.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_10.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_11.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_12.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_13.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_14.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_15.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_16.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_17.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_18.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_19.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_20.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_21.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_22.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_23.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_24.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_25.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_26.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_27.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_28.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_29.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_30.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_31.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_32.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_33.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_34.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_35.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_36.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_37.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_38.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_39.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_40.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_41.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_42.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_43.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_44.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_45.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_46.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_47.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_48.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_49.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_50.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_51.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_52.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_53.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_54.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_55.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_56.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_57.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_58.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_59.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_60.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_61.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_62.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/row_init_63.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init00.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init01.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init02.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init03.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init04.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init05.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init06.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init07.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init08.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init09.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init10.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init11.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init12.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init13.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init14.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init15.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init16.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init17.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init18.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init19.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init20.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init21.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init22.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init23.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init24.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init25.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init26.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init27.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init28.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init29.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init30.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init31.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init32.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init33.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init34.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init35.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init36.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init37.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init38.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init39.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init40.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init41.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init42.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init43.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init44.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init45.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init46.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init47.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init48.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init49.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init50.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init51.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init52.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init53.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init54.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init55.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init56.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init57.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init58.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init59.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init60.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init61.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init62.mem
add_files -norecurse ${PL_SRC_REPO}/mem_init_files/init_files_1024x1024x1024/col_init63.mem
}

update_compile_order -fileset sources_1

ipx::package_project -root_dir [pwd]/ip_repo/${IP_NAME} -vendor xilinx.com -library user -taxonomy /UserIP -import_files -set_current false -force
ipx::unload_core [pwd]/ip_repo/${IP_NAME}/component.xml
ipx::edit_ip_in_project -upgrade true -name tmp_edit_project -directory ./ip_repo/${IP_NAME} [pwd]/ip_repo/${IP_NAME}/component.xml
update_compile_order -fileset sources_1
#ipx::associate_bus_interfaces -clock clk2 -reset interrupt [ipx::current_core]
#ipx::associate_bus_interfaces -clock S_AXI_ACLK -reset interrupt [ipx::current_core]
ipx::associate_bus_interfaces -clock S_AXI_ACLK -reset S_AXI_ARESETN [ipx::current_core]

set_property core_revision 1 [ipx::current_core]
ipx::update_source_project_archive -component [ipx::current_core]
ipx::create_xgui_files [ipx::current_core]
ipx::update_checksums [ipx::current_core]
ipx::save_core [ipx::current_core]
ipx::move_temp_component_back -component [ipx::current_core]
close_project -delete
set_property  ip_repo_paths  [pwd]/ip_repo/${IP_NAME} [current_project]
update_ip_catalog

package_xo -kernel_name ${IP_NAME} -kernel_xml ${PL_SRC_REPO}/${IP_NAME}.xml -ip_directory [pwd]/ip_repo/${IP_NAME} -xo_path [pwd]/${IP_NAME}.xo -force

customize_kernel -xo_path [pwd]/${IP_NAME}.xo -output_xo_path [pwd]/${IP_NAME}.xo -kernel_name ${IP_NAME} -output_kernel ${IP_NAME} -ip_params [list M_LARGE ${GEMM_SIZE} N_LARGE ${GEMM_SIZE}]
