
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity keygen_counter is
    Port ( reset : in std_logic;
           clk : in std_logic;
			  load : in std_logic;
                	  counter_out:out std_logic_vector(1 downto 0)
			  );
end keygen_counter;

architecture behavioral of keygen_counter is

signal counter:std_logic_vector(1 downto 0);

begin

process(reset,clk)
begin
if reset='0' then
  counter<=(others=>'0');
elsif (clk'event and clk='1') then
  if load='1' then
    if counter/="11" then
      counter<=counter+1;
	 else
	   counter<=counter;
	 end if;
  end if;
end if;
end process;

counter_out<=counter;
  
end behavioral;
--<copyright-disclaimer-start>
--  **************************************************************************************************************
--  * © 2025 Advanced Micro Devices, Inc. All rights reserved.                                                   *
--  * DISCLAIMER                                                                                                 *
--  * The information contained herein is for informational purposes only, and is subject to change              *
--  * without notice. While every precaution has been taken in the preparation of this document, it              *
--  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
--  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
--  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
--  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
--  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
--  * hardware, software or other products described herein.  No license, including implied or                   *
--  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
--  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
--  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
--  *                                                                                                            *
--  **************************************************************************************************************
--<copyright-disclaimer-end>